DCMTK: DiMonoInputPixelTemplate< T1, T2, T3 > Class Template Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | Private Member Functions | List of all members
DiMonoInputPixelTemplate< T1, T2, T3 > Class Template Reference

Template class to convert monochrome pixel data to intermediate representation. More...

Inheritance diagram for DiMonoInputPixelTemplate< T1, T2, T3 >:

## Public Member Functions
| DiMonoInputPixelTemplate (DiInputPixel *pixel, DiMonoModality *modality)
| constructor
virtual | ~DiMonoInputPixelTemplate ()
| destructor
Public Member Functions inherited from DiMonoPixelTemplate< T3 >
| DiMonoPixelTemplate (const unsigned long count)
| constructor
| DiMonoPixelTemplate (const DiInputPixel *pixel, DiMonoModality *modality)
| constructor
| DiMonoPixelTemplate (DiMonoOutputPixel *pixel, DiMonoModality *modality)
| constructor
virtual | ~DiMonoPixelTemplate ()
| destructor
EP_Representation | getRepresentation () const
| get integer representation
const void * | getData () const
| get pointer to internal pixel data
void * | getDataPtr ()
| get pointer to internal pixel data
void * | getDataArrayPtr ()
| get reference to pointer to internal pixel data.
int | getMinMaxValues (double &min, double &max) const
| get minimum and maximum pixel values
int | getMinMaxWindow (const int idx, double &center, double &width)
| get automatically computed min-max window
virtual int | getRoiWindow (const unsigned long left_pos, const unsigned long top_pos, const unsigned long width, const unsigned long height, const unsigned long columns, const unsigned long rows, const unsigned long frame, double &voiCenter, double &voiWidth)
| get automatically computed Region of Interest (ROI) window
int | getHistogramWindow (const double thresh, double &center, double &width)
| get automatically computed histogram window
Public Member Functions inherited from DiMonoPixel
| DiMonoPixel (const unsigned long count)
| constructor
| DiMonoPixel (const DiInputPixel *pixel, DiMonoModality *modality)
| constructor
| DiMonoPixel (DiMonoOutputPixel *pixel, DiMonoModality *modality)
| constructor
virtual | ~DiMonoPixel ()
| destructor
int | getPlanes () const
| get number of planes
unsigned int | getBits () const
| get number of bits per pixel
double | getAbsMinimum () const
| get absolute minimum pixel value.
double | getAbsMaximum () const
| get absolute maximum pixel value.
double | getAbsMaxRange () const
| get absolute pixel range
const char * | getModalityLutExplanation () const
| get modality LUT explanation string
DiMonoModality * | addReferenceToModality ()
| add a reference to the internally managed modality transform object
int | isPotentiallySigned () const
| check whether pixel data is 'potentially' signed.
Public Member Functions inherited from DiPixel
| DiPixel (const unsigned long count, const unsigned long inputCount=0)
| constructor
virtual | ~DiPixel ()
| destructor
unsigned long | getCount () const
| get number of pixels
unsigned long | getInputCount () const
| get number of pixels stored in the 'PixelData' element
Public Member Functions inherited from DiPixelRepresentationTemplate< T3 >
| DiPixelRepresentationTemplate ()
| default constructor
virtual | ~DiPixelRepresentationTemplate ()
| destructor
int | isSigned () const
| check whether template type T is signed or not

## Private Member Functions
int | initOptimizationLUT (T3 *&lut, const unsigned long ocnt)
| initialize optimization LUT
void | modlut (DiInputPixel *input)
| perform modality LUT transform
void | rescale (DiInputPixel *input, const double slope=1.0, const double intercept=0.0)
| perform rescale slope/intercept transform

## Additional Inherited Members
Protected Member Functions inherited from DiMonoPixelTemplate< T3 >
| DiMonoPixelTemplate (const DiPixel *pixel, DiMonoModality *modality)
| constructor
| DiMonoPixelTemplate (const DiMonoPixel *pixel, const unsigned long count)
| constructor
void | determineMinMax (T3 minvalue=0, T3 maxvalue=0, const int mode=0x1)
| determine minimum and maximum pixel values
Protected Member Functions inherited from DiMonoPixel
| DiMonoPixel (const DiPixel *pixel, DiMonoModality *modality)
| constructor
| DiMonoPixel (const DiMonoPixel *pixel, const unsigned long count)
| constructor
Protected Attributes inherited from DiMonoPixelTemplate< T3 >
T3 * | Data
| pointer to pixel data
Protected Attributes inherited from DiMonoPixel
DiMonoModality * | Modality
| pointer to modality transform object
Protected Attributes inherited from DiPixel
unsigned long | Count
| number of pixels
unsigned long | InputCount
| number of pixels in the input buffer

## Detailed Description

template<class T1, class T2, class T3>
class DiMonoInputPixelTemplate< T1, T2, T3 >

Template class to convert monochrome pixel data to intermediate representation.

## Constructor & Destructor Documentation

## ◆ DiMonoInputPixelTemplate()

template<class T1, class T2, class T3>

DiMonoInputPixelTemplate< T1, T2, T3 >::DiMonoInputPixelTemplate | ( | DiInputPixel * | pixel,
|  | DiMonoModality * | modality )
| inline

constructor

Parameters

  pixel | pointer to input pixel representation
  modality | pointer to modality transform object

References DiMonoPixelTemplate< T3 >::DiMonoPixelTemplate(), DiPixel::Count, DiMonoPixelTemplate< T3 >::Data, DiMonoPixelTemplate< T3 >::determineMinMax(), DiPixel::InputCount, DiMonoPixel::Modality, modlut(), rescale(), and OFBitmanipTemplate< T >::zeroMem().

## Member Function Documentation

## ◆ initOptimizationLUT()

template<class T1, class T2, class T3>

int DiMonoInputPixelTemplate< T1, T2, T3 >::initOptimizationLUT | ( | T3 *& | lut,
|  | const unsigned long | ocnt )
| inlineprivate

initialize optimization LUT

Parameters

  lut | reference to storage area for lookup table
  ocnt | number of LUT entries (will be check as optimization criteria)

Returns
  status, true if successful (LUT has been created), false otherwise

References DiPixel::InputCount.

Referenced by modlut(), and rescale().

## ◆ modlut()

template<class T1, class T2, class T3>

void DiMonoInputPixelTemplate< T1, T2, T3 >::modlut | ( | DiInputPixel * | input | ) |
| inlineprivate

perform modality LUT transform

Parameters

  input | pointer to input pixel representation

References DiPixel::Count, DiMonoPixelTemplate< T3 >::Data, DiInputPixel::getAbsMaxRange(), DiInputPixel::getAbsMinimum(), DiBaseLUT::getCount(), DiPixel::getCount(), DiInputPixel::getData(), DiInputPixel::getDataPtr(), DiBaseLUT::getFirstEntry(), DiBaseLUT::getFirstValue(), DiBaseLUT::getLastEntry(), DiBaseLUT::getLastValue(), DiInputPixel::getPixelStart(), DiBaseLUT::getValue(), initOptimizationLUT(), DiPixel::InputCount, DiMonoPixel::Modality, and DiInputPixel::removeDataReference().

Referenced by DiMonoInputPixelTemplate().

## ◆ rescale()

template<class T1, class T2, class T3>

void DiMonoInputPixelTemplate< T1, T2, T3 >::rescale | ( | DiInputPixel * | input,
|  | const double | slope = 1.0,
|  | const double | intercept = 0.0 )
| inlineprivate

perform rescale slope/intercept transform

Parameters

  input | pointer to input pixel representation
  slope | rescale slope value (optional)
  intercept | rescale intercept value (optional)

References DiPixel::Count, DiMonoPixelTemplate< T3 >::Data, DiInputPixel::getAbsMaxRange(), DiInputPixel::getAbsMinimum(), DiPixel::getCount(), DiInputPixel::getData(), DiInputPixel::getDataPtr(), DiInputPixel::getPixelStart(), initOptimizationLUT(), DiPixel::InputCount, and DiInputPixel::removeDataReference().

Referenced by DiMonoInputPixelTemplate().

The documentation for this class was generated from the following file:

- dcmimgle/include/dcmtk/dcmimgle/dimoipxt.h

Generated on Wed Apr 30 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2